// myrpc.h
//
// Based on:
// http://mbed.org/projects/cookbook/svn/Servo/trunk/Servo.h
// http://mbed.org/projects/cookbook/svn/Servo/trunk/Servo.cpp

#ifndef MYRPC_H
#define MYRPC_H

#include "mbed.h"

namespace mbed {

class myrpc : public Base {
public:
  myrpc(PinName pin, const char* name = NULL);
  void debug(int val);
  void blink(int n);
  char * echo(const char *);
  void settime(const char *t);
  char *gettime(const char *fmt);
  
#ifdef MBED_RPC
  virtual const struct rpc_method *get_rpc_methods();
  static struct rpc_class *get_rpc_class();
#endif    // MBED_RPC

protected:
    DigitalOut _pin;
    char _buffer[256];     // String buffer
};

}    // namespace mbed
#endif    // MYRPC_H